import picamera
import cv2
import math
"""  # Code permettant de prendre une photo avec
      # la caméra Pi
      
camera = picamera.PiCamera()
camera.resolution=(1024,768)
camera.brightness=60
camera.rotation = 0
camera.crop = (0.0,0.0,1,1)
camera.capture('image.jpg')
camera.close()
"""

image = cv2.imread('clinton.jpg')

#Chargement des clasifieurs
faceCascade = cv2.CascadeClassifier('haarcascade_frontalface_default.xml') #Classifieur pour la detection du visage

""" #Charger:
eyeCascade=
mouthCascade=
noseCascade=
"""

def cadre_face(un_cadre):
    print('x1,y1----+')
    print('|    |')
    print('+-------x2,y2')

    print('x1: ',un_cadre[0][0])
    print('y1: ',un_cadre[0][1])
    print('x2: ',un_cadre[0][0]+un_cadre[0][2])
    print('y2: ',un_cadre[0][1]+un_cadre[0][3])

#Detection des elements et placement des rectangles
    #Recherche visage
faces = faceCascade.detectMultiScale(image, 1.3, 5) #Detection du visage dans l'image
for(xf, yf, wf, hf) in faces: #Definition des coordonnees du visage detecte
    cv2.rectangle(image, (xf,yf), (xf+wf, yf+hf),(0, 0, 255), 1) #Placement du rectangle autour du visage


""" #Extraire de l'image le visage détécté, et le placer dans la donnée roi:

    roi=
""" 

""" #Selectionner roi_superieur: deux premiers tiers des lignes

    roi_superieur=
"""
""" #Selectionner roi_inferieur: dernier tiers des lignes

    roi_inferieur=
"""


    #Recherche yeux
    eyes=[]
    scalefactor_eyes=3
    while not(len(eyes)==2):
        print(scalefactor_eyes)

"""    #Rechercher les yeux
        eyes =  # recherche des yeux dans roi_superieur par la méthode detectMultiScale, avec scalefactor_eyes 
                #comme paramètre

"""
        print(eyes)
        scalefactor_eyes=scalefactor_eyes-0.1 #Decremente de 10%
        
    centre_yeux=[]
    for (xe, ye, we, he) in eyes: #Definition des coordonnees des yeux detectes

""" #placer des rectangles autour des yeux, dans roi

        cv2.rectangle(... ) 
"""

        #placement d'un point au centre de chaque oeil, dans roi

        cv2.circle(roi, (int(xe+we/2),int(ye+he/2)), 2, (0, 0, 255), 1)

        centre_yeux.append(xe+we/2)
        centre_yeux.append(ye+he/2)
    
    #Recherche bouche
    mouth=[]
    scalefactor_mouth=3
    while not(len(mouth)==1):
        print(scalefactor_mouth)
""" 
        mouth = # recherche de la bouche dans roi_inferieur par la méthode detectMultiScale, avec scalefactor_mouth
                #comme paramètre

"""
        print(mouth)
        scalefactor_mouth=scalefactor_mouth-0.1 #Decremente de 10%
    
    for (xm, ym, wm, hm) in mouth: #Definition des coordonnees de la bouche detectee
""" #placer un rectangle autour de la bouche, dans roi

        cv2.rectangle(... ) 
"""        
""" #placer un point au centre de la bouche, dans roi

        cv2.circle(... ) 
"""

    
    #Recherche nez
    nose=[]
    scalefactor_nose=3
    while not(len(nose)==1):
        print(scalefactor_nose)

"""     
        nose = # recherche du nez dans roi par la méthode detectMultiScale, avec scalefactor_nose
                #comme paramètre

"""

        print(nose)
        scalefactor_nose=scalefactor_nose-0.1 #Decremente de 10%

    for (xn, yn, wn, hn) in nose: #Definition des coordonnees du nez detecte

""" #placer un rectangle autour du nez, dans roi

        cv2.rectangle(... ) 
"""        
""" #placer un point au centre du nez, dans roi

        cv2.circle(... ) 
"""

        
#appel de fonction pour afficher les coordonnees du visage
cadre_face(faces)

#Dessin des lignes
cv2.line (roi, (int(centre_yeux[0]),int(centre_yeux[1])), (int(centre_yeux[2]),int(centre_yeux[3])), (0, 0, 255), 2) #Ligne oeil-oeil
cv2.line (roi, (int(centre_yeux[0]),int(centre_yeux[1])), (int(xm+wm/2),int(ym+2*hf/3+hm/2)), (0, 0, 255), 2) #Ligne oeil-bouche
cv2.line (roi, (int(centre_yeux[2]),int(centre_yeux[3])), (int(xm+wm/2),int(ym+2*hf/3+hm/2)), (0, 0, 255), 2) #Ligne oeil-bouche

""" #Placer une ligne entre la bouche et le nez

cv2.line () #Ligne bouche-nez

"""


#Mesure de distances
detection=[]
    #Distance nez-bouche
vecteur_nez_bouche_x = ((xm+wm/2)-(xn+wn/2))
vecteur_nez_bouche_y = ((ym+2*hf/3+hm/2)-(yn+hn/2))
distance_nez_bouche = math.sqrt((math.pow(vecteur_nez_bouche_x, 2))+(math.pow(vecteur_nez_bouche_y, 2)))
print(distance_nez_bouche)
detection.append(distance_nez_bouche)

    #Distance oeil-oeil
vecteur_oeil1_oeil2_x = ((centre_yeux[0])-(centre_yeux[1]))
vecteur_oeil1_oeil2_y = ((centre_yeux[2])-(centre_yeux[3]))
distance_oeil1_oeil2 = math.sqrt((math.pow(vecteur_oeil1_oeil2_x, 2))+(math.pow(vecteur_oeil1_oeil2_y, 2)))
print(distance_oeil1_oeil2)
detection.append(distance_oeil1_oeil2)

#Affichage et sauvegarde de l'image capturee
cv2.imwrite('test_detection.jpg',image)
namewindow = 'Visages detectes'
cv2.imshow(namewindow,image)
cv2.resizeWindow(namewindow,800,600)
cv2.waitKey(0)
cv2.destroyWindow(namewindow)

#Base de donnees
#personnages={}


